#include <stdbool.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "hashmap.h"

void clear_buffer() {
    int c;
    while ((c = getchar()) != '\n' && c != EOF) {
    }
}

int main() {
    struct hm_t *hm = hm_create(2);

    while (true) {
        printf("1=exit, 2=add, 3=delete, 4=search: ");
        int action;
        scanf("%d", &action);
        clear_buffer();

        if (action < 1 || action > 4) {
            printf("Invalid action!\n");
            continue;
        }

        char key[100];
        char value[100];

        if (action == 1) {
            break;
        } else if (action == 2) {
            printf("Phone Number: ");
            scanf("%s", key);
            clear_buffer();

            printf("Name: ");
            scanf("%s", value);
            clear_buffer();

            char *a = strdup(key);
            char *b = strdup(value);
            hm_set(hm, a, b);
        } else if (action == 3) {
            printf("Phone Number: ");
            scanf("%s", key);
            clear_buffer();

            char *c = hm_rm(hm, key);
            free(c);
        } else if (action == 4) {
            printf("Phone Number: ");
            scanf("%s", key);
            clear_buffer();

            char *v = hm_get(hm, key);
            printf("Name = %s\n", v);
        }
    }

    hm_destroy(&hm);
    return EXIT_SUCCESS;
}
